=== metview/test/macros/CMakeLists.txt ===

# ------------------------------------------------------------------------
# MACRO metview_etc_files
# Ensures the files listed in ETC_FILES are copied to the build directory
# and that they will be installed at install time
# ------------------------------------------------------------------------


set (POST_INSTALL_TEST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh)
set (MVRUN "${INSTALLED_METVIEW_STARTUP_SCRIPT}")


macro(metview_macro_test)
    set(options)
    set(single_value_args MACRO)
    set(multi_value_args RESOURCES MACRO_ARGS)
    cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}" ${_FIRST_ARG} ${ARGN} )


    ecbuild_add_test(TARGET      ${_PAR_MACRO}.test
                     COMMAND     ${FULL_STARTUP_SCRIPT_PATH}
                     TYPE        SCRIPT
                     ARGS        -nocreatehome -b ${_PAR_MACRO} ${_PAR_MACRO_ARGS}
                     RESOURCES   ${_PAR_MACRO} ${_PAR_RESOURCES} test_utils.mv )


    # add to the post-install tests too
    string (REPLACE ";" " " MACRO_ARGS "${_PAR_MACRO_ARGS}")  # ';' -> ' '
    file(APPEND ${POST_INSTALL_TEST_SCRIPT} "${MVRUN} -b ${_PAR_MACRO} ${MACRO_ARGS}\n")

    set(all_tests "${all_tests}${_PAR_MACRO} ") # note the spacing
endmacro()



# write the start of the post-install test script
file(WRITE  ${POST_INSTALL_TEST_SCRIPT} "#!/bin/sh\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# Run the tests on the installed version of Metview\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# -------------------------------------------------\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "set -eax\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")



set(all_tests) # empty to start with



if(ENABLE_PLOTTING)
    metview_macro_test(MACRO     HelloWorld.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     layoutx3.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     plot_from_read_grib.mv
                       RESOURCES set_output.mv ../data/fc_data.grib)

    metview_macro_test(MACRO     plot_bufr.mv
                       RESOURCES set_output.mv ../data/temp_10.bufr)
endif()

if(NOT ENABLE_PLOTTING)
    metview_macro_test(MACRO     no_plotting.mv)
endif()

metview_macro_test(MACRO     grib_dates.mv
                   RESOURCES  ../data/fc_data.grib
                              ../data/hindcast.grib
                              ../data/fc_long_step.grib
                              ../data/monthly_avg.grib
                              ../data/flexpart_minute_step.grib)

metview_macro_test(MACRO     grib_keys.mv
                   RESOURCES  ../data/fc_data.grib)


metview_macro_test(MACRO     grib_gradient.mv
                   RESOURCES  ../data/grad_input_global.grib
                              ../data/grad_ref_global.grib
                              ../data/grad_input_global_sn.grib
                              ../data/grad_ref_global_sn.grib
                              ../data/u_sn_reg_ll.grib
                              ../data/grad_ref_u_sn.grib
                              ../data/second_deriv_input_global.grib
                              ../data/second_deriv_ref_global.grib
                              ../data/div_vor_ref.grib
                              ../data/laplace_ref.grib)

metview_macro_test(MACRO     grib_integral.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb
                              ../data/LL_2x2_cellarea_ref.grib
                              ../data/t1000_reg_gg_N48.grib
                              ../data/t1000_red_gg_N48.grib
                              ../data/rgg_small_subarea.grib
                              ../data/reg_gg_N48_cellarea_ref.grib
                              ../data/red_gg_N48_cellarea_ref.grib
                              ../data/rgg_small_subarea_cellarea_ref.grib)

metview_macro_test(MACRO     grib_nearest_gridpoint.mv
                   RESOURCES  ../data/t1000_LL_1x1.grb
                              ../data/t1000_LL_1x1_subarea.grb
                              ../data/t1000_LL_2x2.grb
                              ../data/t1000_LL_2x2_with_missing.grb
                              ../data/t1000_reg_gg_N48.grib
                              ../data/t1000_red_gg_N48.grib
                              ../data/ll_no_pole.grib
                              ../data/rgg_small_subarea.grib
                              ../data/regular_gaussian_subarea.grib
                              ../data/rgg_western_subarea.grib
                              ../data/reduced_ll.grib
                              ../data/nearest_gridpoint_gpt_ref_missing_1.gpt
                              ../data/nearest_gridpoint_gpt_ref_missing_2.gpt)

metview_macro_test(MACRO     grib_vertical.mv
                   RESOURCES ../data/t_lnsp_ml137.grb
                             ../data/pres_ml137.grib
                             ../data/thickness_ml137.grib
                             ../data/vertint_ref.grib
                             ../data/tq_ml137.grib
                             ../data/z_ml137_ref.grib
                             ../data/ml2pl_ref.grib
                             ../data/ml_to_hl_asl_ref.grib
                             ../data/ml_to_hl_agr_ref.grib
                             ../data/t_80Pa.grib
                             ../data/omega_ml.grib
                             ../data/omega_pl.grib)

metview_macro_test(MACRO     interpolation_sh_to_ll.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_sh_to_rgg.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_rgg_to_ll.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

metview_macro_test(MACRO     interp_default.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

if (HAVE_PPROC_EMOS AND HAVE_PPROC_MIR)
    metview_macro_test(MACRO     interp_emos.mv
                       RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)
endif()

if (HAVE_PPROC_MIR)
    metview_macro_test(MACRO     interp_mir.mv
                       RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)
endif()

metview_macro_test(MACRO     grib_to_gpt.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/mercator.grib)

metview_macro_test(MACRO     gpt_to_grib_core.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/gpt_to_grib_reciprocal_reference.grb
                              ../data/gpt_to_grib_exp_mean_reference.grb
                              ../data/gpt_to_grib_exp_sum_reference.grb)

metview_macro_test(MACRO     gpt_to_grib_with_template.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb ../data/10U_GG.grb)

metview_macro_test(MACRO     gpt_to_grib_nearest.mv
                   RESOURCES  ../data/t1000_LL_7x7.grb
                              ../data/example_XYLDTZ.geo
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/gpt_to_grib_nearest_mean_reference.grb
                              ../data/gpt_to_grib_nearest_count_reference.grb
                              ../data/nearest_gridpoint_gpt_ref_1.gpt)

metview_macro_test(MACRO     geopoint_types.mv
                   RESOURCES  ../data/bufr_obs_filter_basic_reference.gpt
                              ../data/example_POLAR_VECTOR.geo
                              ../data/example_XYZ.geo
                              ../data/example_XY_VECTOR.geo)

metview_macro_test(MACRO     gpt_set.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/bufr_picker_reference.gpt
                              ../data/bufr_obs_filter_area_reference.gpt
                              ../data/bufr_obs_filter_custom_reference.gpt
                              ../data/nearest_gridpoint_gpt_ref_1.gpt
                              ../data/t1000_LL_1x1.grb
                              ../data/hindcast.grib)

#metview_macro_test(MACRO     interpolation_gg_to_subarea.mv
#                   RESOURCES  ../data/10U_GG.grb)

metview_macro_test(MACRO     bufr_obs_filter.mv
                   RESOURCES  ../data/bufr-3.bufr
                              ../data/compress_3.bufr
                              ../data/bufr_obs_filter_basic_reference.gpt
                              ../data/temp_10.bufr
                              ../data/bufr_obs_filter_level_reference.gpt
                              ../data/synop_multi_subset_uncompressed.bufr
                              ../data/bufr_obs_filter_area_reference.gpt
                              ../data/bufr_obs_filter_missvals_1_reference.gpt
                              ../data/bufr_obs_filter_missvals_2_reference.gpt
                              ../data/amsua_13.bufr
                              ../data/bufr_obs_filter_time_reference.gpt
                              ../data/bufr_obs_filter_custom_reference.gpt
                              ../data/bufr_obs_filter_blockstation_reference.gpt
                              ../data/aircraft_10.bufr
                              ../data/trop1.bufr
                              ../data/bufr_obs_filter_descriptor_string_reference.gpt
                              ../data/bufr_obs_filter_subtype_reference.gpt
                              ../data/temp_small.bufr
                              ../data/bufr_obs_filter_ncols_reference.gpt
                              ../data/bufr_obs_filter_ncols_miss_reference.gpt
                              ../data/missing_ident.bufr
                              ../data/stnid_with_internal_spaces.bufr
                              ../data/bufr_obs_filter_ncols_stnids_spaces_reference.gpt
                              ../data/ssd_missing_location.bufr
                              ../data/ssd_missing_location_ref.gpt
                              )

metview_macro_test(MACRO     bufr_picker.mv
                   RESOURCES  ../data/temp_10.bufr ../data/bufr_picker_reference_ws.gpt
                              ../data/cape-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_compressed_reference.gpt
                              ../data/2t-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_uncompressed_reference.gpt
                              ../data/temp_small.bufr ../data/bufr_picker_ncols_reference.gpt)

if(ENABLE_UI)
metview_macro_test(MACRO     bufr_filter.mv
                   RESOURCES  ../data/temp_small.bufr ../data/aircraft_small.bufr
                            ../data/ens_multi_subset_uncompressed.bufr
                            ../data/ens_multi_subset_compressed.bufr
                            ../data/synop_multi_subset_uncompressed.bufr
                            ../data/tropical_cyclone.bufr
                            ../data/wave_uncompressed.bufr
                            ../data/compress_3.bufr
                            ../data/stnid_with_internal_spaces.bufr
                            ../data/syn_new.bufr)
endif()

metview_macro_test(MACRO     inline_c.mv
                   RESOURCES ../data/z500.grb)

if(HAVE_METVIEW_FORTRAN)
metview_macro_test(MACRO     inline_fortran.mv
                   RESOURCES ../data/z500.grb)

metview_macro_test(MACRO     spectra.mv
                   RESOURCES ../data/z_for_spectra.grib)

metview_macro_test(MACRO     pottf.mv
                   RESOURCES ../data/thermo_profile.grib
                             ../data/theta_input_pl.grib
                             ../data/theta_pl_ref.grib
                             ../data/theta_ml_ref.grib)
endif()

metview_macro_test(MACRO     station.mv)

metview_macro_test(MACRO     unix.mv)
