=== debian/changelog ===
metview (5.11.0-1ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Help cmake find TiRPC library

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 28 Apr 2021 18:32:33 +0200

metview (5.11.0-1) unstable; urgency=medium

  * New upstream release
  * ecbcuild.patch: Fix for FTBFS when FPIC is empty.
  * Ship Mir Masks in data file; install
  * Enable build tools

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 29 Mar 2021 11:14:25 +0100
